#
# spec file for package gcc-mainline (Version 4.0.0)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  dejagnu expect glibc-devel-32bit gmp gnat gnat-runtime tcl tk x-devel-packages

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs autoconf automake binutils dejagnu expat expect fontconfig fontconfig-devel gcc gdbm gettext glibc-32bit glibc-devel-32bit gmp gnat libtool perl rpm tcl tk

Name:         gcc-mainline
%define _prefix /opt/gcc-mainline
%define _libdir %{_prefix}/%{_lib}
URL:          http://gcc.gnu.org/
%define gcc_for_opt 1
# Just touch RUN_TESTS in the source dir to run the testsuite.
%define run_tests %(test -f %_sourcedir/RUN_TESTS && echo 1 || echo 0)
%ifarch alpha %ix86 ia64 x86_64 s390 s390x ppc sparc
# Gnat is broken on Tree-SSA
%define build_gnat 0
%else
%define build_gnat 0
%endif
%ifarch %ix86 ia64
%define build_gnat_shared %{build_gnat}
%else
%define build_gnat_shared 0
%endif
%ifarch mips armv4l hppa
%define build_java 0
%else
%define build_java 1
%endif
%ifarch x86_64 s390x sparc64 ppc64
%define biarch 1
%else
%define biarch 0
%endif
# Define version number of libgcc_s
%ifarch hppa
%define libgcc_s 2
%else
%define libgcc_s 1
%endif
%ifarch x86_64 ia64 s390x sparc64 alpha ppc64
# 64-bit is primary build target
%define build_primary_64bit 1
%else
%define build_primary_64bit 0
%endif
License:      GPL
Version:      4.0.0
Release:      8.1
%define gcc_version 4.0.0
%define snapshot_date 20040929
%if %{gcc_for_opt}
%define binsuffix -4.0
%define versionspecificlibs 1
%else
%define binsuffix %{nil}
%define versionspecificlibs 0
%endif
#settings for AMD test compiler medium model
%define build_java 0
%define build_gnat 0
%define build_gnat_shared 0
%define biarch 0
Group:        Development/Languages/C and C++
Provides:     c_compiler
Requires:     binutils glibc-devel cpp-mainline = %{version}-%{release} 
Autoreqprov:  on
Summary:      The GNU C Compiler and Support Files (Tree-SSA Branch)
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Source:       gcc-%{gcc_version}-%{snapshot_date}.tar.bz2
Patch1:       bug-reporting.patch
Patch2:       gcc-noalias-warn.diff
Patch3:       ada-makefile.patch
Patch4:       gcc32-ada-addr2line.patch
Patch5:       gcc32-ada-link.patch
Patch7:       ffi.patch
Patch8:       tree-ssa-alias.c.diff
Patch9:       endless-loop-warning.patch
Patch10:      pr17151.patch
Patch11:      medium-new4-gcc.diff
Patch12:      medium-constfix.diff
Patch13:      mudflap-install.diff

%description
This is a development version of GCC taken from the tree-ssa branch.



Authors:
--------
    Adam Fedor <fedor@colorado.edu>
    Alan Modra <alan@spri.levels.unisa.edu.au>
    Allen Briggs <briggs@rrinc.com>
    Andreas Schwab <schwab@suse.de>
    Andreas Jaeger <aj@suse.de>
    Andrew Cagney <cagney@highland.com.au>
    Andrew McCallum <mccallum@leopard.cs.rochester.edu>
    Arne H. Juul <arnej@idt.unit.no>
    Craig Burley <burley@gnu.ai.mit.edu>
    DJ Delorie <dj@delorie.com>
    David Edelsohn <edelsohn@mhpcc.edu>
    Doug Evans <dje@cygnus.com>
    Douglas Rupp <drupp@cs.washington.edu>
    Fergus Henderson <fjh@cs.mu.oz.au>
    Gran Uddeborg <uddeborg@carmen.se>
    Ian Lance Taylor <ian@cygnus.com>
    Jrn Rennecke <amylaar@meolyon.hanse.de>
    J.T. Conklin <jtc@cygnus.com>
    Jason Merrill <jason@cygnus.com>
    Jan Hubicka <jh@suse.cz>
    Jeffrey A. Law <law@cygnus.com>
    Jim Meyering <meyering@na-net.ornl.gov>
    Jim Wilson <wilson@cygnus.com>
    John F. Carr <jfc@mit.edu>
    Ken Raeburn <raeburn@wombat.gnu.ai.mit.edu>
    Lee Iverson <leei@ai.sri.com>
    Linus Torvalds <torvalds@transmeta.com>
    Michael Gschwind <mike@lanai.vlsivie.tuwien.ac.at>
    Michael Meissner <meissner@cygnus.com>
    Mike Stump <mrs@cygnus.com>
    Niklas Hallqvist <niklas@appli.se>
    Oliver Kellogg <oliver.kellogg@space.otn.dasa.de>
    Pat Rankin <rankin@eql.caltech.edu>
    Paul Eggert <eggert@twinsun.com>
    Per Bothner <bothner@cygnus.com>
    Peter Flass <flass@lbdrscs.bitnet>
    Philippe De Muyter <phdm@info.ucl.ac.be>
    Philipp Thomas <pthomas@suse.de>
    Richard Earnshaw <rearnsha@armltd.co.uk>
    Richard Kenner <kenner@vlsi1.ultra.nyu.edu>
    Richard Stallman <rms@mole.gnu.ai.mit.edu>
    Roland McGrath <roland@churchy.gnu.ai.mit.edu>
    Stan Cox <coxs@dg-rtp.dg.com>
    Stephen L Moshier <moshier@world.std.com>
    Ted Lemon <mellon@toccata.fugue.com>
    Tom Quiggle <quiggle@lovelace.engr.sgi.com>
    Torbjorn Granlund <tege@cygnus.com>
    Uwe Seimet <seimet@chemie.uni-kl.de>

%package c++
Requires:     libstdc++-devel-mainline
Summary:      The GNU C++ Compiler
Group:        Development/Languages/C and C++
Autoreqprov:  on
Requires:     gcc-mainline = %{version}-%{release}
Requires:     libstdc++-mainline = %{version}
Requires:     libstdc++-devel-mainline = %{version}
%if %{gcc_for_opt}
Provides:     c++_compiler
%else
Provides:     gpp c++_compiler
Obsoletes:    gpp
%endif

%description c++
This package contains the GNU compiler for C++.



%package -n libstdc++-devel-mainline
Summary:      Include Files and Libraries mandatory for Development
Group:        System/Libraries
Autoreqprov:  on
Requires:     libstdc++-mainline = %{version}-%{release}
%if !%{gcc_for_opt}
Provides:     libgpp
Obsoletes:    libgpp
%endif

%description -n libstdc++-devel-mainline
This package contains all the headers and libraries of the standard C++
library. It is needed for compiling C++ code.

The source code is in the package gcc.



%package -n libgcc-mainline
Summary:      C compiler runtime library
Group:        System/Base
Requires:     libgcc
Autoreqprov:  on

%description -n libgcc-mainline
Libgcc is needed for dynamically linked C programs.



%package -n libstdc++-mainline
Summary:      The standard C++ shared library
Group:        System/Libraries
Autoreqprov:  on
%if !%{gcc_for_opt}
Provides:     gppshare
Obsoletes:    gppshare
%endif

%description -n libstdc++-mainline
The standard C++ library, needed for dynamically linked C++ programs.



Authors:
--------
    Paolo Carlini <pcarlini@unitus.it>
    Gabriel Dos Reis <gdr@integrable-solutions.net>
    Ulrich Drepper <drepper@redhat.com>
    Phil Edwards <pme@gcc.gnu.org>
    Benjamin Kosnik <bkoz@redhat.com>
    Loren J. Rittle <ljrittle@acm.org>
    et.al.

%package info
Summary:      GNU info-pages for gcc
Group:        Development/Languages/C and C++
Autoreqprov:  on
Provides:     gccinfo
Obsoletes:    gccinfo
Conflicts:    gcc-info

%description info
GNU info-pages for gcc



%package objc
Summary:      GNU Objective C Compiler
Group:        Development/Languages/Other
Requires:     gcc-mainline = %{version}-%{release} libobjc-mainline = %{version}-%{release}
Autoreqprov:  on
%if !%{gcc_for_opt}
Provides:     gobjc
Obsoletes:    gobjc
%endif

%description objc
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.



%package -n libobjc-mainline
Summary:      The library for the GNU Objective C compiler
Group:        Development/Libraries/Other
Autoreqprov:  on

%description -n libobjc-mainline
The library for the GNU Objective C compiler.



%package -n cpp-mainline
Summary:      The GCC Preprocessor
Group:        Development/Languages/C and C++
%if !%{gcc_for_opt}
Obsoletes:    minigcc
Provides:     minigcc
%endif
Autoreqprov:  on

%description -n cpp-mainline
This Package contains just the preprocessor that is used by the XFree86
packages.



%package java
Requires:     gcc-mainline = %{version}-%{release} libgcj-devel-mainline = %{version}-%{release}
Summary:      The GNU Java Compiler
Group:        Development/Languages/Java
Autoreqprov:  on
Requires:     libgcj-mainline = %{version}
Requires:     libgcj-devel-mainline = %{version}
%if !%{gcc_for_opt}
Provides:     gjava
Obsoletes:    gjava
%endif

%description java
The java compiler from the GCC-tools-suite.



%package -n libgcj-mainline
Summary:      Java Runtime Library for gcc
Group:        System/Libraries
Autoreqprov:  on

%description -n libgcj-mainline
This library is needed if you want to use the GNU Java compiler, gcj.
Source code for this package is in gcc.



%package -n libgcj-devel-mainline
Requires:     libgcj-mainline = %{version}-%{release}
Summary:      Java development libraries for gcc
Group:        Development/Libraries/Java
Autoreqprov:  on
Requires:     libgcj-mainline = %{version}

%description -n libgcj-devel-mainline
Java development libraries for gcc



%package -n gnat-mainline
# XXX: We should rename gnat to gcc-ada and gnat-runtime to libada
Requires:     gcc-mainline = %{version}-%{release}
%if %{build_gnat_shared}
Requires:     gnat-runtime-mainline
%endif
Summary:      GNU Ada95 Compiler based on gcc (GNAT)
Group:        Development/Languages/Other
Autoreqprov:  on

%description -n gnat-mainline
This package contains an Ada95 compiler and associated development
tools based on the GNU gcc technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from sources you
must have installed a binary version to bootstrap the compiler.



%package -n gnat-runtime-mainline
Summary:      GNU Ada runtime libraries
Group:        System/Libraries
Autoreqprov:  on
%if !%{gcc_for_opt}
Provides:     gnat-3.13p-runtime
Obsoletes:    gnat-3.13p-runtime
%endif

%description -n gnat-runtime-mainline
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries. It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the Posix
1003.5 Binding (Florist).



%package fortran
Summary:      GNU Fortran Compiler
Group:        Development/Languages/Fortran
Autoreqprov:  on

%description fortran
This version of the GNU Fortran compiler needs a gcc of the same
version. The binaries of the C compiler must be under
/usr/lib/gcc-lib/.../<version>.



Authors:
--------
    James Craig Burley <burley@gnu.ai.mit.edu>
    Toon Moene <toon@moene.indiv.nluug.nl>
    et.al.

%package mudflap
Summary:      The GNU C Compiler and Support Files (Tree-SSA Branch)
Group:        Development/Languages/C and C++
Autoreqprov:  on

%description mudflap
This is a development version of GCC taken from the tree-ssa branch.



Authors:
--------
    Adam Fedor <fedor@colorado.edu>
    Alan Modra <alan@spri.levels.unisa.edu.au>
    Allen Briggs <briggs@rrinc.com>
    Andreas Schwab <schwab@suse.de>
    Andreas Jaeger <aj@suse.de>
    Andrew Cagney <cagney@highland.com.au>
    Andrew McCallum <mccallum@leopard.cs.rochester.edu>
    Arne H. Juul <arnej@idt.unit.no>
    Craig Burley <burley@gnu.ai.mit.edu>
    DJ Delorie <dj@delorie.com>
    David Edelsohn <edelsohn@mhpcc.edu>
    Doug Evans <dje@cygnus.com>
    Douglas Rupp <drupp@cs.washington.edu>
    Fergus Henderson <fjh@cs.mu.oz.au>
    Gran Uddeborg <uddeborg@carmen.se>
    Ian Lance Taylor <ian@cygnus.com>
    Jrn Rennecke <amylaar@meolyon.hanse.de>
    J.T. Conklin <jtc@cygnus.com>
    Jason Merrill <jason@cygnus.com>
    Jan Hubicka <jh@suse.cz>
    Jeffrey A. Law <law@cygnus.com>
    Jim Meyering <meyering@na-net.ornl.gov>
    Jim Wilson <wilson@cygnus.com>
    John F. Carr <jfc@mit.edu>
    Ken Raeburn <raeburn@wombat.gnu.ai.mit.edu>
    Lee Iverson <leei@ai.sri.com>
    Linus Torvalds <torvalds@transmeta.com>
    Michael Gschwind <mike@lanai.vlsivie.tuwien.ac.at>
    Michael Meissner <meissner@cygnus.com>
    Mike Stump <mrs@cygnus.com>
    Niklas Hallqvist <niklas@appli.se>
    Oliver Kellogg <oliver.kellogg@space.otn.dasa.de>
    Pat Rankin <rankin@eql.caltech.edu>
    Paul Eggert <eggert@twinsun.com>
    Per Bothner <bothner@cygnus.com>
    Peter Flass <flass@lbdrscs.bitnet>
    Philippe De Muyter <phdm@info.ucl.ac.be>
    Philipp Thomas <pthomas@suse.de>
    Richard Earnshaw <rearnsha@armltd.co.uk>
    Richard Kenner <kenner@vlsi1.ultra.nyu.edu>
    Richard Stallman <rms@mole.gnu.ai.mit.edu>
    Roland McGrath <roland@churchy.gnu.ai.mit.edu>
    Stan Cox <coxs@dg-rtp.dg.com>
    Stephen L Moshier <moshier@world.std.com>
    Ted Lemon <mellon@toccata.fugue.com>
    Tom Quiggle <quiggle@lovelace.engr.sgi.com>
    Torbjorn Granlund <tege@cygnus.com>
    Uwe Seimet <seimet@chemie.uni-kl.de>

%ifarch sparc sparc64
%if %{biarch}
%define GCCDIST sparc64-suse-linux
%else
%define GCCDIST %{_target_cpu}-suse-linux
%endif
%else
%define GCCDIST %(echo %{_target_cpu}|sed -e "s/i.86/i586/" -e "s/ppc/powerpc/")-suse-linux
%endif
%define libsubdir %{_libdir}/gcc/%{GCCDIST}/%{gcc_version}
%if %{versionspecificlibs}
%define mainlibdir %{libsubdir}
%define mainlibdirbi32 %{libsubdir}/32
%define mainlibdirbi64 %{libsubdir}/64
%define versioninclude %{libsubdir}/include
%ifarch ppc
%define noflibdir %{libsubdir}/nof
%define mainlibdirbi32 %{libsubdir}
%endif
%ifarch ppc64
%define noflibdir %{libsubdir}/32/nof
%endif
%else
%define mainlibdir %{_libdir}
%define mainlibdirbi32 %{_prefix}/lib
%define mainlibdirbi64 %{_prefix}/lib64
%define noflibdir %{_prefix}/lib/nof
%define versioninclude %{_prefix}/include
%endif
%prep
%setup -q -n gcc-%{gcc_version}-%{snapshot_date}
%patch1
%patch2
# XXX Fix the patches to apply cleanly
#%patch3
#%patch4
#%patch5
%patch7
%patch8 -R -p1
%patch9
%patch10 -R
%patch11
%patch12
%patch13

%build
# Update version number
# not changed in ada (gcc/ada/gnatvsn.ads) since otherwise the line
# will be too long
perl -pi -e 's/\((prerelease|experimental|release)\)/\(\1\) \(SUSE Linux\)/' \
    gcc/version.c
# Handle gcc/version.c once again since a release might not have the
# release word in it:
perl -pi -e 's/(version_string.*\"[0-9.]+)\"/\1 \(SUSE Linux\)\"/' \
    gcc/version.c
# Avoid rebuilding of generated files
contrib/gcc_update --touch
rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc sparc64
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch %ix86
# -mcpu is superceded by -mtune but -mtune is not supported by
# our bootstrap compiler.  -mcpu gives a warning that stops
# the build process, so remove it for now.
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-mcpu=i.86//g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-O1/-O2/g'`
%endif
# Replace 2 spaces by one finally
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/  / /g'`
languages=c,c++,objc,f95
%if %{build_java}
languages=$languages,java
%endif
%if %{build_gnat}
languages=$languages,ada
%endif
PARALLEL="%{?jobs:-j%jobs}"
# TEMPORARY until release, you can disable it for faster builds:
# XXX
ENABLE_CHECKING=--enable-checking
#ENABLE_CHECKING=--disable-checking
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" GCJFLAGS="$OPT_FLAGS" \
../configure --enable-threads=posix \
	--prefix=%{_prefix} --with-local-prefix=/usr/local \
	--infodir=%{_infodir} --mandir=%{_mandir} \
	--libdir=%{_libdir} --libexecdir=%{_libdir} \
	--disable-multilib \
	--enable-languages=$languages $ENABLE_CHECKING \
%if !%{build_java}
        --disable-libgcj \
%endif
	--with-slibdir=/%{_lib} --with-system-zlib \
	--enable-shared --enable-__cxa_atexit \
%if %{gcc_for_opt}
	--program-suffix=%{binsuffix} \
%endif
%if %{versionspecificlibs}
	 --enable-version-specific-runtime-libs \
%endif
%ifarch sparc
%if %{biarch}
	--with-cpu=v8 %{GCCDIST}
%else
	--host=%{GCCDIST} --build=%{GCCDIST} --target=%{GCCDIST} --with-cpu=v7
%endif
%else
	%{GCCDIST}
%endif
%if %{biarch}
%ifarch x86_64
# Create this link in case it does not exist
#rm -rf /usr/lib64/32
#ln -s /usr/lib /usr/lib64/32
#rm -rf /lib64/32
#ln -s /lib /lib64/32
%endif
%endif
# XXX: Disable for now
%ifarch x86_64 i386
# Only run profiled bootstrap on a few arches for now
#make profiledbootstrap BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
# XXX
make bootstrap-lean BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
%else
make bootstrap-lean BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
%endif
%if %{build_gnat}
%if %{build_gnat_shared}
#make -C gcc gnatlib-shared
%else
#make -C gcc gnatlib
%endif
make -C gcc gnattools
%endif
make -C gcc proto
make info
%if %{run_tests}
echo "Run testsuite"
make -k check $PARALLEL || true
(make -C %{GCCDIST}/libstdc++-v3 check-abi || true)
%endif

%install
# get Check to pick up man/info pages under /opt
%if %{gcc_for_opt}
manpath=%{_mandir}:%{_infodir}
export manpath
%endif
rm -rf $RPM_BUILD_ROOT
cd obj-%{GCCDIST}
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
export LIBRARY_PATH=$RPM_BUILD_ROOT/%{libsubdir}:$RPM_BUILD_ROOT/%{mainlibdirbi32}:$RPM_BUILD_ROOT/%{mainlibdirbi64}
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}
%if %{versionspecificlibs}
mv $RPM_BUILD_ROOT/%{_prefix}/include/mf-runtime.h $RPM_BUILD_ROOT/%{versioninclude}
%endif
# Move libgcc_s around
%if %{versionspecificlibs}
mv $RPM_BUILD_ROOT/%{_lib}/libgcc_s*.so* $RPM_BUILD_ROOT%{mainlibdir}
%ifarch ia64
mv $RPM_BUILD_ROOT/%{_lib}/libunwind.* $RPM_BUILD_ROOT%{mainlibdir}
%endif
%if %{biarch}
%if %{build_primary_64bit}
mv $RPM_BUILD_ROOT/lib/libgcc_s*.so* $RPM_BUILD_ROOT%{mainlibdirbi32}
ln -sf %{mainlibdirbi32}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s.so
ln -sf %{mainlibdirbi32}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s_32.so
%else
mv $RPM_BUILD_ROOT/lib64/libgcc_s.so* $RPM_BUILD_ROOT%{mainlibdirbi64}
%endif
%ifarch ppc ppc64
# Note: ppc64 has only 32-bit nof libraries
rm -f $RPM_BUILD_ROOT/{_prefix}/lib/libgcc_s_nof.so
ln -sf %{mainlibdirbi32}/libgcc_s_nof.so $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s_nof.so
%endif
%endif
%else #!versionspecificlibs
rm -f $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so
ln -sf /%{_lib}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_libdir}/libgcc_s.so
chmod a+x $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.%{libgcc_s}
%ifarch ia64
mv $RPM_BUILD_ROOT/%{_lib}/libunwind.a $RPM_BUILD_ROOT%{mainlibdir}
%endif
%if %{biarch}
%if %{build_primary_64bit}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s_32.so
chmod a+x $RPM_BUILD_ROOT/lib/libgcc_s.so.%{libgcc_s}
%else
# 32-bit biarch systems
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib64/libgcc_s.so
ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib64/libgcc_s_64.so
chmod a+x $RPM_BUILD_ROOT/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif
%ifarch ppc ppc64
# Note: ppc64 has only 32-bit nof libraries
rm -f $RPM_BUILD_ROOT/lib/libgcc_s_nof.so
ln -sf /lib/libgcc_s_nof.so.%{libgcc_s} $RPM_BUILD_ROOT/%{_prefix}/lib/libgcc_s_nof.so
%endif
%endif
%if %{build_gnat_shared}
mv $RPM_BUILD_ROOT%{libsubdir}/adalib/lib*-*.so $RPM_BUILD_ROOT%{_libdir}
ln -sf %{_libdir}/libgnarl-3.15.so $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnarl.so
ln -sf %{_libdir}/libgnat-3.15.so $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnat.so
chmod a+x $RPM_BUILD_ROOT%{_libdir}/libgna*-*.so
%endif
ln -sf gcc%{binsuffix} $RPM_BUILD_ROOT%{_prefix}/bin/cc%{binsuffix}
ln -sf g++%{binsuffix}  $RPM_BUILD_ROOT%{_prefix}/bin/c++%{binsuffix}
mkdir -p $RPM_BUILD_ROOT/lib
%if !%{gcc_for_opt}
cat <<\EOF > $RPM_BUILD_ROOT/lib/cpp
#!/bin/sh
# Traditionally, /lib/cpp only knew about C
exec %{_prefix}/bin/cpp -xc "$@"
EOF
chmod 755 $RPM_BUILD_ROOT/lib/cpp
%endif
%if %{biarch}
%if %{build_primary_64bit}
# move around some libs that end in wrong paths
pushd .
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
(cd $RPM_BUILD_ROOT%{_libdir}/32; tar cf - *) | (cd $RPM_BUILD_ROOT%{_prefix}/lib ; tar xf -)
rm -rf $RPM_BUILD_ROOT%{_libdir}/32
ln -s %{_prefix}/lib $RPM_BUILD_ROOT%{_libdir}/32
rm -rf $RPM_BUILD_ROOT/%{_lib}/32
ln -s /lib $RPM_BUILD_ROOT/%{_lib}/32
popd
%else
# 32-bit biarch systems
# move around some libs that end in wrong paths
pushd .
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
cd $RPM_BUILD_ROOT%{_libdir}/64
for f in *; do
  mv $RPM_BUILD_ROOT%{_libdir}/64/$f $RPM_BUILD_ROOT%{_prefix}/lib64
done
rm -rf $RPM_BUILD_ROOT%{_libdir}/64
ln -s %{_prefix}/lib $RPM_BUILD_ROOT%{_libdir}/64
popd
%endif
%endif
# Remove some crap from the .la files:
for l in $RPM_BUILD_ROOT%{mainlibdir}/*.la \
%if !%{versionspecificlibs}
%if %{biarch}
%if %{build_primary_64bit}
    $RPM_BUILD_ROOT%{_prefix}/lib/*.la \
%else
    $RPM_BUILD_ROOT%{_prefix}/lib64/*.la \
%endif
%endif
%endif
    ; do
  sed -e '/^dependency_libs/s| -L/usr/src/packages/BUILD/[^ ]*||g' \
      -e '/^dependency_libs/s| -L/usr/%{GCCDIST}/bin||g' \
      -e '/^dependency_libs/s|-lm \(-lm \)*|-lm |' \
      -e '/^dependency_libs/s|-L[^ ]* ||g' \
%if %{biarch}
%if %{build_primary_64bit}
      -e '/^libdir/s|%{_libdir}/32|%{_prefix}/lib|' \
      -e '/^libdir/s|lib64/\.\./||' \
%else
      -e '/^libdir/s|%{_libdir}/64|%{_prefix}/lib64|' \
%endif
%endif
      < $l  > $l.new
  mv $l.new $l
done
%if %{gcc_for_opt}
%ifarch x86_64
perl  -pi -e "s|^(.*elf_i386.*)|\1 %{m32:-rpath=/opt/gcc33/lib} %{\!m32:-rpath=/opt/gcc33/lib64}|;"  $RPM_BUILD_ROOT%{_prefix}/lib64/gcc/x86_64-suse-linux/3.3/specs
%endif
%endif
%if %{run_tests} 
mkdir ../testresults
cp `find . -name "*.sum"` ../testresults/
cp `find . -name "*.log"  \! -name "config.log" ` ../testresults/
%endif
# Remove files that we do not need to clean up filelist
rm -f $RPM_BUILD_ROOT/%{_prefix}/bin/%{GCCDIST}-*
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/install-tools
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/install-tools
rm -rf $RPM_BUILD_ROOT/%{_libdir}/pkgconfig/libgcj.pc
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/include/root/
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/curses.h
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/include/linux/
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/ncurses.h
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/stdio.h
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/zutil.h
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/X11
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/include/bits
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/obstack.h
rm -f $RPM_BUILD_ROOT/%{libsubdir}/include/spe.h
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/include/bits/
rm -rf $RPM_BUILD_ROOT/%{libsubdir}/include/sys
rm -f  $RPM_BUILD_ROOT/%{_infodir}/dir
%if %{build_gnat}
rm $RPM_BUILD_ROOT/%{_infodir}/gnat_ug_vms.info*
rm $RPM_BUILD_ROOT/%{_infodir}/gnat_ug_vxw.info*
rm $RPM_BUILD_ROOT/%{_infodir}/gnat_ug_wnt.info*
%endif
%if %{build_java}
rm -f $RPM_BUILD_ROOT/%{_prefix}/include/ffi*
rm -fr $RPM_BUILD_ROOT/%{libsubdir}/include/libffi/
rm -f $RPM_BUILD_ROOT/%{_libdir}/libffi*
%ifarch ppc ppc64
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib/nof/libffi*
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib/libffi*
%else
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib64/libffi*
%endif
%endif
rm $RPM_BUILD_ROOT/%{_mandir}/man1/jv-convert%{binsuffix}.1
%endif
rm $RPM_BUILD_ROOT/%{_mandir}/man7/fsf-funding.7
rm $RPM_BUILD_ROOT/%{_mandir}/man7/gfdl.7
rm $RPM_BUILD_ROOT/%{_mandir}/man7/gpl.7
rm $RPM_BUILD_ROOT/%{_libdir}/libiberty.a
%ifarch ppc ppc64
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib/nof/libiberty.a
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib/libiberty.a
%else
rm -f $RPM_BUILD_ROOT/%{_prefix}/lib64/libiberty.a
%endif
%endif
# Delete some files...
%if %{versionspecificlibs}
%if %{build_java}
rm $RPM_BUILD_ROOT/%{_libdir}/logging.properties
rm $RPM_BUILD_ROOT/%{_libdir}/security/classpath.security
rm $RPM_BUILD_ROOT/%{_libdir}/security/libgcj.security
%endif
rm $RPM_BUILD_ROOT/%{_infodir}/*.info*
rm $RPM_BUILD_ROOT/%{_prefix}/share/locale/*/LC_MESSAGES/*.mo
%endif

%post info
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/cppinternals.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccint.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccinstall.info.gz
%endif

%postun info
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cppinternals.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccint.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccinstall.info.gz
%endif

%post java
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
%endif

%postun java
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
%endif

%post -n libgcj-mainline
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
%endif

%postun -n libgcj-mainline
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
%endif
%if %{build_gnat}

%post -n gnat-mainline
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/gnat-style.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
%install_info --info-dir=%{_infodir} --section="GNU Ada tools" --entry="* GNAT User's Guide: (gnat_ug_unx). GNAT User's Guide for Unix Platforms" %{_infodir}/gnat_ug_unx.info.gz
%endif
%endif
%if %{build_gnat}

%postun -n gnat-mainline
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat-style.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_ug_unx.info.gz
%endif
%endif

%files
%defattr(-,root,root)
%if %{gcc_for_opt}
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_libdir}
%if %{biarch}
%if %{build_primary_64bit}
%dir %{_prefix}/lib
%endif
%endif
%dir %{_prefix}/share
%dir %{_mandir}
%dir %{_mandir}/man1
%dir %{_prefix}/include
%endif
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%if %{versionspecificlibs}
%if %{biarch}
%if %{build_primary_64bit}
%dir %{mainlibdirbi32}
%else
%dir %{mainlibdirbi64}
%endif
%endif
%endif
%if %{biarch}
%if %{build_primary_64bit}
# This link is essential for correct execution
%{_libdir}/32
/%{_lib}/32
%endif
%endif
%{_prefix}/bin/cc%{binsuffix}
%{_prefix}/bin/gcc%{binsuffix}
%{_prefix}/bin/gccbug%{binsuffix}
%{_prefix}/bin/gcov%{binsuffix}
%{_prefix}/bin/protoize%{binsuffix}
%{_prefix}/bin/unprotoize%{binsuffix}
%{libsubdir}/collect2
%{libsubdir}/*crt*.o
%{libsubdir}/SYSCALLS.c.X
%{libsubdir}/include/README
%{libsubdir}/include/float.h
%{libsubdir}/include/iso646.h
%{libsubdir}/include/limits.h
%{libsubdir}/include/stdarg.h
%{libsubdir}/include/stdbool.h
%{libsubdir}/include/stddef.h
%{libsubdir}/include/syslimits.h
%{libsubdir}/include/unwind.h
%{libsubdir}/include/varargs.h
%ifarch ppc ppc64
%{libsubdir}/include/altivec.h
%{libsubdir}/include/ppc-asm.h
%endif
%ifarch ia64
%{libsubdir}/include/ia64intrin.h
%endif
%ifarch %ix86 x86_64
%{libsubdir}/include/mm3dnow.h
%{libsubdir}/include/mmintrin.h
%{libsubdir}/include/emmintrin.h
%{libsubdir}/include/pmmintrin.h
%{libsubdir}/include/xmmintrin.h
%{libsubdir}/include/mm_malloc.h
%endif
%{libsubdir}/libgcc.a
%{libsubdir}/libgcc_eh.a
%{libsubdir}/libgcov.a
%if %{biarch}
%if %{build_primary_64bit}
%if !%{versionspecificlibs}
%dir %{libsubdir}/32
%endif
%{libsubdir}/32/crt*
%{libsubdir}/32/libgcc*a
%if %{versionspecificlibs}
%{libsubdir}/32/libgcc_s*.so
%endif
%{libsubdir}/32/libgcov.a
%else
%{libsubdir}/64/crt*
%{libsubdir}/64/libgcc*
%{libsubdir}/64/libgcov.a
%endif
%endif
%ifarch ppc
%dir %{libsubdir}/nof
%{libsubdir}/nof/*crt*
%{libsubdir}/nof/libgcc*
%{libsubdir}/nof/libgcov.a
%endif
%ifarch ppc64
#%{libsubdir}/32/nof
%endif
%ifarch ia64
%{mainlibdir}/libunwind.a
%endif
%if %{versionspecificlibs}
%{mainlibdir}/libgcc_s.so
%ifarch ppc ppc64
%{mainlibdirbi32}/libgcc_s_nof.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcc_s.so
%{mainlibdirbi32}/libgcc_s_32.so
%else
%ifnarch sparc
# 32-bit biarch systems
%{mainlibdirbi64}/libgcc_s.so
%{mainlibdirbi64}/libgcc_s_64.so
%endif
%endif
%endif
%else
%{_libdir}/libgcc_s.so
%ifarch ppc ppc64
%{_prefix}/lib/libgcc_s_nof.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{_prefix}/lib/libgcc_s.so
%{_prefix}/lib/libgcc_s_32.so
%else
%ifnarch sparc
# 32-bit biarch systems
%{_prefix}/lib64/libgcc_s.so
%{_prefix}/lib64/libgcc_s_64.so
%endif
%endif
%endif
%endif
%doc %{_mandir}/man1/gcc%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcov%{binsuffix}.1.gz
%if !%{versionspecificlibs}
%{_prefix}/share/locale/*/LC_MESSAGES/gcc.mo
%{_prefix}/share/locale/*/LC_MESSAGES/cpplib.mo
%endif
%if %{run_tests}
%doc testresults/*.sum
%doc testresults/*.log
%endif

%files c++
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/c++%{binsuffix}
%{_prefix}/bin/g++%{binsuffix}
%doc %{_mandir}/man1/g++%{binsuffix}.1.gz
%{libsubdir}/cc1plus

%files -n libstdc++-devel-mainline
%defattr(-,root,root)
%{versioninclude}/c++
%{mainlibdir}/libstdc++.a
%{mainlibdir}/libstdc++.la
%{mainlibdir}/libstdc++.so
%{mainlibdir}/libsupc++.a
%{mainlibdir}/libsupc++.la
%ifarch ppc ppc64
%{noflibdir}/libstdc++.a
%{noflibdir}/libstdc++.la
%{noflibdir}/libstdc++.so
%{noflibdir}/libsupc++.a
%{noflibdir}/libsupc++.la
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libstdc++.a
%{mainlibdirbi32}/libstdc++.la
%{mainlibdirbi32}/libstdc++.so
%{mainlibdirbi32}/libsupc++.a
%{mainlibdirbi32}/libsupc++.la
%else
%ifnarch sparc
%{_prefix}/lib64/libstdc++.a
%{_prefix}/lib64/libstdc++.la
%{_prefix}/lib64/libstdc++.so
%{_prefix}/lib64/libsupc++.a
%{_prefix}/lib64/libsupc++.la
%endif
%endif
%endif
%doc libstdc++-v3/docs/html

%files -n libgcc-mainline
%defattr(-,root,root)
%if %{versionspecificlibs}
%{mainlibdir}/libgcc_s.so.%{libgcc_s}
%ifarch ia64
%{mainlibdir}/libunwind.so.7
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcc_s.so.%{libgcc_s}
%else
%ifnarch sparc
%{mainlibdirbi64}/libgcc_s.so.%{libgcc_s}
%endif
%endif
%endif
%ifarch ppc ppc64
%{mainlibdirbi32}/libgcc_s_nof.so.%{libgcc_s}
%endif
%else
# not versionspecificlibs
/%{_lib}/libgcc_s.so.%{libgcc_s}
%ifarch ia64
/%{_lib}/libunwind.so.7
%endif
%ifarch ppc ppc64
/lib/libgcc_s_nof.so.%{libgcc_s}
%endif
%if %{biarch}
%if %{build_primary_64bit}
/lib/libgcc_s.so.%{libgcc_s}
%else
%ifnarch sparc
/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif
%endif
%endif

%files -n libstdc++-mainline
%defattr(-,root,root)
%{mainlibdir}/libstdc++.so.*
%ifarch ppc ppc64
%{noflibdir}/libstdc++.so.*
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libstdc++.so.*
%else
%ifnarch sparc
%{_prefix}/lib64/libstdc++.so.*
%endif
%endif
%endif
%if !%{versionspecificlibs}
%{_prefix}/share/locale/*/LC_MESSAGES/libstdc++.mo
%endif

%files fortran
%defattr(-,root,root)
%{_prefix}/bin/gfortran%{binsuffix}
%{libsubdir}/f951
%{mainlibdir}/libgfortran.a
%{mainlibdir}/libgfortran.la
%{mainlibdir}/libgfortran.so.*
%{mainlibdir}/libgfortranbegin.a
%{mainlibdir}/libgfortranbegin.la
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgfortran.a
%{mainlibdirbi32}/libgfortran.la
%{mainlibdirbi32}/libgfortran.so.*
%{mainlibdirbi32}/libgfortranbegin.a
%{mainlibdirbi32}/libgfortranbegin.la
%else
%{mainlibdirbi64}/libgfortran.a
%{mainlibdirbi64}/libgfortran.la
%{mainlibdirbi64}/libgfortran.so.*
%{mainlibdirbi64}/libgfortranbegin.a
%{mainlibdirbi64}/libgfortranbegin.la
%endif
%endif
%ifarch ppc ppc64
%{noflibdir}/libgfortran.a
%{noflibdir}/libgfortran.la
%{noflibdir}/libgfortran.so.*
%{noflibdir}/libgfortranbegin.a
%{noflibdir}/libgfortranbegin.la
%endif
%if !%{versionspecificlibs}
%doc %{_infodir}/gfortran.info*.gz
%endif
%doc %{_mandir}/man1/gfortran%{binsuffix}.1.gz

%files mudflap
%defattr(-,root,root)
%{mainlibdir}/libmudflap.a
%{mainlibdir}/libmudflap.la
%{mainlibdir}/libmudflap.so*
%{mainlibdir}/libmudflapth.a
%{mainlibdir}/libmudflapth.la
%{mainlibdir}/libmudflapth.so.*
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libmudflap.a
%{mainlibdirbi32}/libmudflap.la
%{mainlibdirbi32}/libmudflap.so*
%{mainlibdirbi32}/libmudflapth.a
%{mainlibdirbi32}/libmudflapth.la
%{mainlibdirbi32}/libmudflapth.so.*
%else
%ifnarch sparc
%{_prefix}/lib64/libmudflap.a
%{_prefix}/lib64/libmudflap.la
%{_prefix}/lib64/libmudflap.so*
%{_prefix}/lib64/libmudflapth.a
%{_prefix}/lib64/libmudflapth.la
%{_prefix}/lib64/libmudflapth.so.*
%endif
%endif
%endif
%ifarch ppc ppc64
%{noflibdir}/libmudflap.a
%{noflibdir}/libmudflap.la
%{noflibdir}/libmudflap.so*
%{noflibdir}/libmudflapth.a
%{noflibdir}/libmudflapth.la
%{noflibdir}/libmudflapth.so.*
%endif
%{versioninclude}/mf-runtime.h
%if !%{versionspecificlibs}

%files info
%defattr(-,root,root)
%doc %{_infodir}/cpp.info*.gz
%doc %{_infodir}/cppinternals.info*.gz
%doc %{_infodir}/gcc.info*.gz
%doc %{_infodir}/gccint.info*.gz
%doc %{_infodir}/gccinstall.info*.gz
%endif

%files -n cpp-mainline
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%if !%{gcc_for_opt}
/lib/cpp
%endif
%{_prefix}/bin/cpp%{binsuffix}
%{libsubdir}/cc1
%{libsubdir}/specs
%doc %{_mandir}/man1/cpp%{binsuffix}.1.gz

%files objc
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%{libsubdir}/cc1obj
%{libsubdir}/include/objc
%{mainlibdir}/libobjc.a
%{mainlibdir}/libobjc.la
%{mainlibdir}/libobjc.so
%ifarch ppc ppc64
%{noflibdir}/libobjc.a
%{noflibdir}/libobjc.la
%{noflibdir}/libobjc.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libobjc.a
%{mainlibdirbi32}/libobjc.la
%{mainlibdirbi32}/libobjc.so
%else
%ifnarch sparc
%{_prefix}/lib64/libobjc.a
%{_prefix}/lib64/libobjc.la
%{_prefix}/lib64/libobjc.so
%endif
%endif
%endif

%files -n libobjc-mainline
%defattr(-,root,root)
%{mainlibdir}/libobjc.so.*
%ifarch ppc ppc64
%{noflibdir}/libobjc.so.*
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libobjc.so.*
%else
%ifnarch sparc
%{_prefix}/lib64/libobjc.so.*
%endif
%endif
%endif
%if %{build_java}

%files java
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/gcj%{binsuffix}
%{_prefix}/bin/gcjh%{binsuffix}
%{_prefix}/bin/jcf-dump%{binsuffix}
%{_prefix}/bin/jv-scan%{binsuffix}
%if !%{versionspecificlibs}
%dir %{_libdir}/security
%{_libdir}/security/classpath.security
%{_libdir}/security/libgcj.security
%endif
%{libsubdir}/jc1
%{libsubdir}/jvgenmain
%if !%{versionspecificlibs}
%doc %{_infodir}/gcj.info*.gz
%endif
%doc %{_mandir}/man1/gcj%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcjh%{binsuffix}.1.gz
%doc %{_mandir}/man1/jcf-dump%{binsuffix}.1.gz
%doc %{_mandir}/man1/jv-scan%{binsuffix}.1.gz

%files -n libgcj-mainline
%defattr(-,root,root)
%{_prefix}/bin/gij%{binsuffix}
%{_prefix}/bin/grepjar%{binsuffix}
%{_prefix}/bin/jv-convert%{binsuffix}
%{_prefix}/bin/fastjar%{binsuffix}
%{_prefix}/bin/grmic%{binsuffix}
%{_prefix}/bin/grmiregistry%{binsuffix}
%{_prefix}/share/java/libgcj-%{gcc_version}.jar
%{mainlibdir}/libgcj.so.*
%{mainlibdir}/libgij.so.*
%{mainlibdir}/lib-org*.so.*
%if !%{versionspecificlibs}
%{_libdir}/logging.properties
%endif
%ifarch ppc ppc64
%dir %{noflibdir}
%{noflibdir}/libgcj.so.*
%{noflibdir}/libgij.so.*
%{noflibdir}/lib-org*.so.*
%if %{versionspecificlibs}
%{noflibdir}/libgcj.spec
%endif
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcj.so.*
%{mainlibdirbi32}/libgij.so.*
%{mainlibdirbi32}/lib-org*.so.*
%else
%ifnarch sparc
%{mainlibdirbi64}/libgcj.so.*
%{mainlibdirbi64}/libgij.so.*
%{mainlibdirbi64}/lib-org*.so.*
%endif
%endif
%endif
%if !%{versionspecificlibs}
%doc %{_infodir}/fastjar.info*.gz
%endif
%doc %{_mandir}/man1/gij%{binsuffix}.1.gz
%doc %{_mandir}/man1/grepjar%{binsuffix}.1.gz
%doc %{_mandir}/man1/fastjar%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmic%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmiregistry%{binsuffix}.1.gz
# These files conflict with the normal Java packages
#%doc %{_mandir}/man1/jv-convert.1.gz

%files -n libgcj-devel-mainline
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%{_prefix}/bin/addr2name.awk%{binsuffix}
%{versioninclude}/j*.h
%{versioninclude}/gcj
%{versioninclude}/gnu
%{versioninclude}/java
%{versioninclude}/javax
%{mainlibdir}/libgcj.a
%{mainlibdir}/libgcj.la
%{mainlibdir}/libgcj.so
%{mainlibdir}/libgcj.spec
%{mainlibdir}/libgij.a
%{mainlibdir}/libgij.la
%{mainlibdir}/libgij.so
%{mainlibdir}/lib-org*.a
%{mainlibdir}/lib-org*.la
%{mainlibdir}/lib-org*.so
%ifarch ppc ppc64
%{noflibdir}/libgcj.a
%{noflibdir}/libgcj.la
%{noflibdir}/libgcj.so
%{noflibdir}/libgij.a
%{noflibdir}/libgij.la
%{noflibdir}/libgij.so
%{noflibdir}/lib-org*.a
%{noflibdir}/lib-org*.la
%{noflibdir}/lib-org*.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcj.a
%{mainlibdirbi32}/libgcj.la
%{mainlibdirbi32}/libgcj.so
%{mainlibdirbi32}/libgij.a
%{mainlibdirbi32}/libgij.la
%{mainlibdirbi32}/libgij.so
%{mainlibdirbi32}/lib-org*.a
%{mainlibdirbi32}/lib-org*.la
%{mainlibdirbi32}/lib-org*.so
%if %{versionspecificlibs}
%{mainlibdirbi32}/libgcj.spec
%endif
%else
%ifnarch sparc
%{mainlibdirbi64}/libgcj.a
%{mainlibdirbi64}/libgcj.la
%{mainlibdirbi64}/libgcj.so
%{mainlibdirbi64}/libgij.a
%{mainlibdirbi64}/libgij.la
%{mainlibdirbi64}/libgij.so
%{mainlibdirbi64}/lib-org*.a
%{mainlibdirbi64}/lib-org*.la
%{mainlibdirbi64}/lib-org*.so
%{mainlibdirbi64}/libgcj.spec
%endif
%endif
%endif
%if !%{versionspecificlibs}
%{libsubdir}/include/gcj
%endif
%endif
%if %{build_gnat}

%files -n gnat-mainline
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/gnat*
%{libsubdir}/adainclude
%dir %{libsubdir}/adalib
%{libsubdir}/adalib/Makefile.adalib
%{libsubdir}/adalib/*.ali
%{libsubdir}/adalib/*.a
%if %{build_gnat_shared}
%{libsubdir}/adalib/libgnarl.so
%{libsubdir}/adalib/libgnat.so
%endif
%{libsubdir}/gnat1
%if !%{versionspecificlibs}
%doc %{_infodir}/gnat-style.info*gz
%doc %{_infodir}/gnat_rm.info*gz
%doc %{_infodir}/gnat_ug_unx.info*gz
%endif
%if %{build_gnat_shared}

%files -n gnat-runtime-mainline
%defattr(-,root,root)
%{_libdir}/libgnarl-*.so
%{_libdir}/libgnat-*.so
%ifarch ppc
%{noflibdir}/libgnarl-*.so
%{noflibdir}/libgnat-*.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{_prefix}/lib/libgnarl-*.so
%{_prefix}/lib/libgnat-*.so
%else
%ifnarch sparc
%{_prefix}/lib64/libgnarl-*.so
%{_prefix}/lib64/libgnat-*.so
%endif
%endif
%endif
# build_gnat_shared
%endif
# build_gnat
%endif

%changelog -n gcc-mainline
* Fri Oct 01 2004 - matz@suse.de
- add medium model patches
* Wed Sep 29 2004 - aj@suse.de
- Update to current CVS.
* Fri Sep 24 2004 - aj@suse.de
- Remove obsolete patch for head +1.
* Fri Sep 24 2004 - schwab@suse.de
- Update to current CVS.
* Mon Sep 20 2004 - aj@suse.de
- Update to current CVS.
* Sat Sep 18 2004 - schwab@suse.de
- Remove extra header.
* Sat Sep 18 2004 - aj@suse.de
- Update to current CVS.
* Fri Sep 17 2004 - aj@suse.de
- Update to current CVS.
* Thu Sep 16 2004 - aj@suse.de
- Update to current CVS.
* Wed Sep 15 2004 - aj@suse.de
- Update to current CVS.
* Tue Sep 14 2004 - aj@suse.de
- Update to current CVS.
- Fix spec file for PPC.
- Add patch to fix some aliasing issues.
* Mon Sep 13 2004 - aj@suse.de
- GCC 3.5 is now GCC 4.0.
- Update to current CVS.
- Fix package list.
* Fri Sep 10 2004 - aj@suse.de
- Do no pack libgcc_s.so.1 twice.
* Thu Sep 09 2004 - aj@suse.de
- Update to current CVS.
- Adjust spec file for changes.
* Thu Sep 02 2004 - aj@suse.de
- Fix for powerpc.
- Update to current CVS.
* Fri Aug 27 2004 - aj@suse.de
- Use DESTDIR again after setting LD_LIBRARY_PATH.
* Fri Aug 27 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Do not use DESTDIR/RPM_BUILD_ROOT since libtool will not
  install java correctly with it.
* Fri Aug 20 2004 - aj@suse.de
- Fix RPM_OPT_FLAGS.
- Update to current 3.5 CVS.
* Thu Aug 19 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Mon Aug 09 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Mon Jul 19 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Fix /usr install.
* Wed Jun 16 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Install into /usr.
* Thu Jun 10 2004 - aj@suse.de
- Fix build on PPC.
- Update to current 3.5 CVS.
* Wed Jun 09 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Fri Jun 04 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Fix spec file for x86-64 and hppa.
* Thu Jun 03 2004 - aj@suse.de
- Fix spec file.
- Update to current 3.5 CVS.
* Wed Jun 02 2004 - aj@suse.de
- Update to current 3.5 CVS, rework spec file.
* Thu May 27 2004 - aj@suse.de
- Update to GCC 3.5 CVS.
* Wed Apr 28 2004 - aj@suse.de
- Update to current CVS.
* Tue Apr 20 2004 - aj@suse.de
- Avoid warnings.
- Update to current 3.4 CVS.
* Fri Apr 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Sat Mar 13 2004 - aj@suse.de
- Fix spec file.
- Update to current 3.4 CVS.
* Tue Mar 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Tue Mar 02 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Fri Feb 27 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Wed Feb 18 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Mon Feb 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Mon Feb 02 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 26 2004 - aj@suse.de
- Update to current CVS.
* Fri Jan 23 2004 - aj@suse.de
- Update to current CVS.
* Thu Jan 22 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 19 2004 - aj@suse.de
- Update to current CVS.
* Fri Jan 16 2004 - aj@suse.de
- Update to current CVS.
* Wed Jan 14 2004 - aj@suse.de
- Update to current CVS.
- Fix spec file.
* Tue Jan 13 2004 - aj@suse.de
- Fix package list.
* Tue Jan 13 2004 - aj@suse.de
- Disable Ada on AMD64.
* Tue Jan 13 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 12 2004 - aj@suse.de
- Update to current CVS.
* Wed Jan 07 2004 - aj@suse.de
- Update to current CVS.
* Tue Dec 16 2003 - aj@suse.de
- Update to current CVS.
- change config-dist.sh to check-build.sh.
- minimal-toc is not needed anymore on ppc64.
- Fix PPC nof file list.
* Wed Dec 10 2003 - aj@suse.de
- Update to current CVS.
* Thu Dec 04 2003 - aj@suse.de
- Update to current CVS.
- Fix package list.
* Wed Dec 03 2003 - aj@suse.de
- Update to current CVS.
* Sun Nov 30 2003 - aj@suse.de
- Update to current CVS.
* Fri Nov 28 2003 - aj@suse.de
- Update to current CVS.
* Wed Oct 29 2003 - aj@suse.de
- Fix package list for i386.
* Wed Oct 29 2003 - aj@suse.de
- New package.
